'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _apolloClient = require('apollo-client');

var _apolloClient2 = _interopRequireDefault(_apolloClient);

var _reactApollo = require('react-apollo');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (gqlQuery) {
    var matchVariables = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function () {
        return {};
    };
    var endpoint = arguments[2];

    var client = new _apolloClient2.default({
        networkInterface: (0, _apolloClient.createNetworkInterface)({ uri: endpoint || '/api/query/graphql' })
    });

    return function (Component) {
        return function ResolveGraphglConnector(props) {
            var GraphQLConnector = (0, _reactApollo.graphql)((0, _reactApollo.gql)(gqlQuery), {
                options: function options(ownProps) {
                    return { variables: matchVariables(ownProps) };
                }
            })(Component);

            return _react2.default.createElement(
                _reactApollo.ApolloProvider,
                { client: client },
                _react2.default.createElement(GraphQLConnector, props)
            );
        };
    };
};